#include "guecs/sfml/config.hpp"
#include <fmt/core.h>

using nlohmann::json;
using fmt::format;

Config::Config(const std::string src_path) : $src_path(src_path) {
  std::ifstream infile($src_path);
  $config = json::parse(infile);
}

json &Config::operator[](const std::string &key) {
  assert($config.contains(key) &&
      "ERROR in config, key doesn't exist.");
  return $config[key];
}

std::wstring Config::wstring(const std::string main_key, const std::string sub_key) {
  assert($config.contains(main_key) && "ERROR wstring main/key in config, main_key doesn't exist.");
  assert($config[main_key].contains(sub_key) && "ERROR wstring in config, main_key/key doesn't exist.");

  const std::string& str_val = $config[main_key][sub_key];
  std::wstring_convert<std::codecvt_utf8_utf16<wchar_t>> $converter;
  return $converter.from_bytes(str_val);
}

std::vector<std::string> Config::keys() {
  std::vector<std::string> the_fucking_keys;

  for(auto& [key, value] : $config.items()) {
    the_fucking_keys.push_back(key);
  }

  return the_fucking_keys;
}
